local ffi = require 'ffi'
local lj_include = require 'lj_include'

ffi.cdef[[
struct sigaction {
    union {
	__sighandler_t sa_handler;
	void (*sa_sigaction) (int, siginfo_t *, void *);
    } __sigaction_handler;
    __sigset_t sa_mask;
    int sa_flags;
    void (*sa_restorer) (void);
};
]]

local defs = {
    SA_NOCLDSTOP = '1',
    SA_NOCLDWAIT = '2',
    SA_SIGINFO = '4',
    SA_ONSTACK = '0x08000000',
    SA_RESTART = '0x10000000',
    SA_NODEFER = '0x40000000',
    SA_RESETHAND = '0x80000000',
    SA_INTERRUPT = '0x20000000',
    SA_NOMASK = '0x40000000',
    SA_ONESHOT = '0x80000000',
    SA_STACK = '0x08000000',
    SIG_BLOCK = '0',
    SIG_UNBLOCK = '1',
    SIG_SETMASK = '2',
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

