local ffi = require 'ffi'
local lj_include = require 'lj_include'

lj_include('endian')

ffi.cdef[[
union wait {
    int w_status;
    struct {
	unsigned int:16;
	unsigned int __w_retcode:8;
	unsigned int __w_coredump:1;
	unsigned int __w_termsig:7;
    } __wait_terminated;
    struct {
	unsigned int:16;
	unsigned int __w_stopsig:8;
	unsigned int __w_stopval:8;
    } __wait_stopped;
};
]]

local defs = {
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

