local ffi = require 'ffi'
local lj_include = require 'lj_include'

ffi.cdef[[
char *optarg;
int optind;
int opterr;
int optopt;
int getopt(int ___argc, char *const *___argv, const char *__shortopts);
]]

local defs = {
    no_argument = '0',
    required_argument = '1',
    optional_argument = '2',
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

