local ffi = require 'ffi'
local lj_include = require 'lj_include'

lj_include('bits_types')
lj_include('time')
lj_include('bits_time')
lj_include('sys_select')

ffi.cdef[[
struct xxx_timezone {
    int tz_minuteswest;
    int tz_dsttime;
};
typedef struct timezone *__timezone_ptr_t;
int gettimeofday(struct timeval *__tv, __timezone_ptr_t __tz);
int settimeofday(const struct timeval *__tv, const struct timezone *__tz);
int adjtime(const struct timeval *__delta, struct timeval *__olddelta);
enum __itimer_which {
    XXX_ITIMER_REAL = 0,
    XXX_ITIMER_VIRTUAL = 1,
    XXX_ITIMER_PROF = 2
};
struct xxx_itimerval {
    struct timeval it_interval;
    struct timeval it_value;
};
typedef enum __itimer_which __itimer_which_t;
int getitimer(__itimer_which_t __which, struct itimerval *__value);
int setitimer(__itimer_which_t __which,
    const struct itimerval *__new, struct itimerval *__old);
int utimes(const char *__file, const struct timeval __tvp[2]);
int lutimes(const char *__file, const struct timeval __tvp[2]);
int futimes(int __fd, const struct timeval __tvp[2]);
int futimesat(int __fd, const char *__file, const struct timeval __tvp[2]);
]]

