(function($) {
    "use strict";
    var queue = [];
    var commands;
    var in_dispatch = false;
    var inhibit = false;
    var initialized = false;

    commands = {
        '%register_commands' : function(c) {
            $.extend(commands, c);
            if (!initialized) {
                $('body').ajaxSend(function(e, jqhrx, opts) {
                    if (in_dispatch) {
                        inhibit = true;
                        opts.armada_command = true;
                    }
                });
                $('body').ajaxComplete(function(e, jqhrx, opts) {
                    if (opts.armada_command) {
                        inhibit = false;
                        dispatch();
                    }
                });
                initialized = true;
            }
        }
    };

    function dispatch() {
        in_dispatch = true;
        while (queue.length > 0 && !inhibit) {
            var cmd = queue[0];
            (commands[cmd[0]])(cmd[1], cmd[2]);
            queue.shift();
        }
        in_dispatch = false;
    }

    $.command = function(cmd, args, origin) { // KLUDGE?
        if (origin === 'immediate') {
            // You'd better know what you're doing...!!
            (commands[cmd])(args, 'local');
            return;
        }
        queue.push([cmd, args, origin || 'local']);

        if (queue.length === 1) { // lock: already in dispatch() if length > 1
            dispatch();
        }
    };
}(jQuery));
